function report_works (reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportWorksWidget = reporting.Base.extend({
        template: 'ReportWorks',
        invoice: [],
        Currency:[],
        resCurrency :[],
        resCompany:[],
        accountJournal:[],
        supplier:[],
        content:[],
        rowsData :[],
        // event
        events:{
            'click #toolbar > button' : 'clickOnAction',
            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click-row.bs.table #table ' : 'ckickAnalysisDetail',
        },
        // Initil
        init : function(parent){
            this._super(parent);
        },
        // start
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },
        // Analisis Detallado
        ckickAnalysisDetail: function(e, row, $element,field){
            if (field == 'customer'){
                this.do_action({
                    name:"Registro del Cliente",
                    type: 'ir.actions.act_window',
                    res_model: "res.partner",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.customer_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.customer_id,
                });
            }
            e.stopImmediatePropagation();
        },
        // Consultar
        submitForm: function () {
            var self = this;
            self.fetchCarCar().then(function(CarCar) {
                return CarCar;
            }).then(function(CarCar){
                self.CarCar = CarCar;
                return self.fetchCarWorkShop();
            }).then(function (CarWorkShop){
                self.CarWorkShop = CarWorkShop;
                return self.fetchAccountInvoice();
            }).then(function(AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.fetchCarService();
            }).then(function(CarService){
                self.CarService = CarService;
                return self.fetchResPartner();
            }).then(function(ResPartner){
                self.ResPartner = ResPartner; 
                self.search();
                return self.buildTable();
                
            });
        },
        // Fecha
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },
        fetchCarCar: function () {
            var self = this;
            var defer = $.Deferred();
            var CarCar = new instance.web.Model('car.car');
            CarCar.query(['id', 'name','policy','partner_id','agent_id','date_in']).filter([['task_ids','!=', false]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fetchCarWorkShop: function () {
            var self = this;
            var defer = $.Deferred();
            var CarWorkShop = new instance.web.Model('car.workshop');
            CarWorkShop.query(['id', 'name','vehicle_id','state']).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fetchAccountInvoice: function () {
            var self = this;
            var defer = $.Deferred();
            var AccountInvoice = new instance.web.Model('account.invoice');
            AccountInvoice.query(['id', 'number','amount_total','residual','work_invoice_id','state']).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fetchCarService: function () {
            var self = this;
            var defer = $.Deferred();
            var CarService = new instance.web.Model('car.service');
            CarService.query(['id','name','secure_id']).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var ResPartner = new instance.web.Model('res.partner');
            ResPartner.query(['id','name','ruc']).filter([['active','=',true],['customer','=',true]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        // Buscador
        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.name,
                        value: item.id + '-'+ item.name
                }
            });
            self.$('#customer').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#customer').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },
        getCarWorkShop : function(id){
            var self = this;
            return _.filter(self.CarWorkShop, function(item){
                return item.vehicle_id[0] == id;
            });
        },
        getAccountInvoice : function(id){
            var self = this;
            return _.filter(self.AccountInvoice, function(item){
                return item.work_invoice_id[0] == id;
            });
        },
        getCarService : function(id){
            var self = this;
            return _.filter(self.CarService, function(item){
                return item.id == id;
            });
        },
        buildTable: function(){
            var self = this;
            var CarCar = self.CarCar;
            var task;
            var invoice;
            var state;
            var data = [];
            var car;
            var agente;
            _.each(CarCar, function(item){
                task = self.getCarWorkShop(item.id);
                car = self.getCarService(item.name[0])
                var pay_amount = 0;
                var collect_pay = 0;
                var secure_amount = 0;
                var particular_amount = 0;
                invoice = self.getAccountInvoice(task[0].id);
                if(invoice.length>0){
                    if (item.policy) {
                        secure_amount = invoice[0].amount_total;
                        particular_amount = 0;
                    }else{
                        secure_amount = 0;
                        particular_amount = invoice[0].amount_total;
                    }
                    pay_amount = invoice[0].amount_total - invoice[0].residual;
                    collect_pay = invoice[0].residual;
                }
                if (task[0].state === 'waiting') {
                    state = 'No Facturado';
                } else {
                    state = 'Facturado';
                }
                if (item.agent_id.length == undefined) {
                    agente = 'Particular';
                }else{
                    agente = item.agent_id[1];
                }      
                data.push({
                    id : item.id,
                    customer_id : item.partner_id[0],
                    customer : item.partner_id[1],
                    car : item.name[1],
                    agent : agente,
                    date_in : moment(item.date_in).format("DD/MM/YYYY"),
                    date : item.date_in,
                    secure_amount : accounting.formatNumber(secure_amount,0,".",","),
                    particular_amount : accounting.formatNumber(particular_amount,0,".",","),
                    state : state,
                    pay_amount : accounting.formatNumber(pay_amount,0,".",","),
                    collect : accounting.formatNumber(collect_pay,0,".",","),
                    intsecure_amount : secure_amount,
                    intparticular_amount : particular_amount,
                    intpay_amount : pay_amount,
                    intcollect : collect_pay

                });
            });
            self.content = data;
            this.loadTable(data);
        },
        // Buscar
        factSearch: function(){
            var self = this;
            var desde =this.$el.find('#from').val();
            var hasta =this.$el.find('#to').val();
            var customer= this.$el.find('#customer').val().split('-');
            var content = self.content;
            if (desde.length > 0){
                var date= desde.split('/');
                content = _.filter(content, function (inv){
                    return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                });
            }
            if (hasta.length > 0){
                var date= hasta.split('/');
                content = _.filter(content, function (inv){
                    return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                });
            }
            if (customer != ""){
                content = _.filter(content, function(inv){
                    return inv.customer_id == customer[0];
                });
            }
            self.loadTable(content)
        },
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },
        getObjetPdf: function(){
            var self = this;
            var rows=[];
            rows = self.rowsData;

            // valor Aseguradora
            var secure_total = _.reduce(_.map(rows,function(map){
                return(map.intsecure_amount);
            }),function(memo, num){
                return memo + num;
            },0);
            // valor Particular
            var particular_total = _.reduce(_.map(rows,function(map){
                return(map.intparticular_amount);
            }),function(memo, num){
                return memo + num;
            },0); 
            // Monto ya cobrado
            var pay_total = _.reduce(_.map(rows,function(map){
                return(map.intpay_amount);
            }),function(memo, num){
                return memo + num;
            },0); 
            // Monto a Cobrar
            var collect_total = _.reduce(_.map(rows,function(map){
                return(map.intcollect);
            }),function(memo, num){
                return memo + num;
            },0); 
            rows.push({
                id : '',
                customer : 'Totales',
                car : '',
                agent : '',
                date_in : '',
                secure_amount : accounting.formatNumber(secure_total,0,".",","),
                particular_amount : accounting.formatNumber(particular_total,0,".",","),
                state : '',
                pay_amount : accounting.formatNumber(pay_total,0,".",","),
                collect : accounting.formatNumber(collect_total,0,".",",")
            });
            return rows;
        },
        // imprimir PDF
        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
        },

        // Generar pdfDoc
        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF('l');

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    customer : {columnWidth: '8px'},
                    car : {columnWidth: '8px'},
                    agent : {columnWidth: '8px'},
                    date_in : {halign:'center',columnWidth: '5px'},
                    secure_amount : {halign:'right',columnWidth: '8px'},
                    particular_amount : {halign:'right',columnWidth: '8px'},
                    state: {halign:'right',columnWidth: '8px'},
                    pay_amount: {halign:'right',columnWidth: '8px'},
                    collect: {halign:'right',columnWidth: '8px'},
                },
                margin: { top: 16, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Histórico de trabajos ', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+ desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+ hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Informe de Trabajos.pdf')
        },
    });
}
